# class JBClientEngine | A Jabber client engine. More...
Full name | `TelEngine::JBClientEngine`
Definition | `#include <libs/yjabber/yatejabber.h>`
Inherits | TelEngine::JBEngine [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- JBClientEngine (const char* name = "jbclientengine")
- ~JBClientEngine ()
- virtual void cleanup (bool final = false, bool waitTerminate = true)
- JBClientStream* findAccount (const String& account)
- JBClientStream* create (const String& account, const NamedList& params, const String& name = String::empty())
- virtual void getStreamList (RefPointer& list, int type)

#### Protected Methods

- virtual void addStream (JBStream* stream)
- virtual void removeStream (JBStream* stream, bool delObj = true)
- virtual void stopStreamSets (bool waitTerminate = true)

#### Protected Members

- JBStreamSetList* m_receive
- JBStreamSetList* m_process

## Detailed Description

This class implements a Jabber client engine

JBClientEngine (const char* name = "jbclientengine") | ### JBClientEngine

Constructor

Parameters:

name | Engine name

~JBClientEngine () | ### ~JBClientEngine

Destructor

void cleanup (bool final = false, bool waitTerminate = true) | ### cleanup

[virtual]

Terminate all streams. Stop all sets processors. Release memory if final

Parameters:

final | True if called from destructor
waitTerminate | True to wait for all streams to terminate

Reimplemented from JBEngine.

JBClientStream* findAccount (const String& account) | ### findAccount

Find a stream by account

Parameters:

account | Account name

Returns: Referenced JBClientStream pointer or 0

JBClientStream* create (const String& account, const NamedList& params, const String& name = String::empty()) | ### create

Build an outgoing client stream

Parameters:

account | Account name
params | Stream parameters
name | Optional stream name

Returns: Referenced JBClientStream pointer or 0 if a stream already exists

void getStreamList (RefPointer& list, int type) | ### getStreamList

[virtual]

Retrieve the list of streams of a given type

Parameters:

list | The destination list to set
type | Stream type

Reimplemented from JBEngine.

void addStream (JBStream* stream) | ### addStream

[protected virtual]

Add a stream to one of the stream lists

Parameters:

stream | The stream to add

Reimplemented from JBEngine.

void removeStream (JBStream* stream, bool delObj = true) | ### removeStream

[protected virtual]

Remove a stream

Parameters:

stream | The stream to remove
delObj | True to release the stream, false to remove it from list without releasing it

Reimplemented from JBEngine.

void stopStreamSets (bool waitTerminate = true) | ### stopStreamSets

[protected virtual]

Stop all stream sets

Parameters:

waitTerminate | True to wait for all streams to terminate

Reimplemented from JBEngine.

JBStreamSetList* m_receive | ### m_receive

[protected]

JBStreamSetList* m_process | ### m_process

[protected]

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.